"use strict";
/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-02-18 13:28:42
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.seek = exports.splice = void 0;
/**
 * remove item in array, find it first
 * @param input
 * @param item
 * @param replace
 */
function splice(input, item, ...replace) {
    const index = input.indexOf(item);
    if (index > -1) {
        input.splice(index, 1, ...replace);
    }
    return index;
}
exports.splice = splice;
/**
 * get element of array by index, allow out of range [0, array.length)
 * @param input
 * @param index
 */
function seek(input, index) {
    index = index % input.length;
    index = index < 0 ? input.length + index : index;
    return input[index];
}
exports.seek = seek;
//# sourceMappingURL=array.js.map