"use strict";
/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-03-27 18:05:39
 */
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const flag_1 = require("./flag");
describe('flag', () => {
    it('should set flag', () => {
        class FlagSpec {
            constructor() {
                this.flags = 0;
                this.k1 = false;
                this.k2 = true;
            }
        }
        (0, tslib_1.__decorate)([
            (0, flag_1.flag)(1 << 0)
        ], FlagSpec.prototype, "k1", void 0);
        (0, tslib_1.__decorate)([
            (0, flag_1.flag)(1 << 1)
        ], FlagSpec.prototype, "k2", void 0);
        const item = new FlagSpec();
        expect(item.flags).toBe(1 << 1);
        expect(item.k1).toBe(false);
        expect(item.k2).toBe(true);
        item.k1 = true;
        expect(item.flags).toBe((1 << 1) | 1);
        expect(item.k1).toBe(true);
        expect(item.k2).toBe(true);
        item.k2 = false;
        expect(item.flags).toBe(1);
        expect(item.k1).toBe(true);
        expect(item.k2).toBe(false);
        expect(() => {
            (0, flag_1.flag)(1 << 1)(FlagSpec.prototype, 'k2');
        }).toThrow('mask 10 is used before set "k2"');
    });
});
//# sourceMappingURL=flag.spec.js.map