/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-03-27 18:05:39
 */
import { __decorate } from "tslib";
import { flag } from './flag';
describe('flag', function () {
    it('should set flag', function () {
        var FlagSpec = /** @class */ (function () {
            function FlagSpec() {
                this.flags = 0;
                this.k1 = false;
                this.k2 = true;
            }
            __decorate([
                flag(1 << 0)
            ], FlagSpec.prototype, "k1", void 0);
            __decorate([
                flag(1 << 1)
            ], FlagSpec.prototype, "k2", void 0);
            return FlagSpec;
        }());
        var item = new FlagSpec();
        expect(item.flags).toBe(1 << 1);
        expect(item.k1).toBe(false);
        expect(item.k2).toBe(true);
        item.k1 = true;
        expect(item.flags).toBe((1 << 1) | 1);
        expect(item.k1).toBe(true);
        expect(item.k2).toBe(true);
        item.k2 = false;
        expect(item.flags).toBe(1);
        expect(item.k1).toBe(true);
        expect(item.k2).toBe(false);
        expect(function () {
            flag(1 << 1)(FlagSpec.prototype, 'k2');
        }).toThrow('mask 10 is used before set "k2"');
    });
});
//# sourceMappingURL=flag.spec.js.map