"use strict";
/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-01-17 14:07:02
 */
Object.defineProperty(exports, "__esModule", { value: true });
const consts_1 = require("./consts");
const ip_1 = require("./ip");
describe('ip', () => {
    const DEFAULT_INT = 0xfabcdef00;
    const DEFAULT_IP = '11.22.33.44';
    const cases = [
        ['0.0.0.0', 0],
        ['255.255.255.255', consts_1.UINT32_MAX],
        ['127.0.0.1', 2130706433],
        ['0.0.0.1', 1],
        ['::1', DEFAULT_INT],
        [DEFAULT_IP, Math.pow(2, 32)],
    ];
    it('should convert ip', () => {
        cases.forEach(([ip, int]) => {
            if (ip !== DEFAULT_IP) {
                expect((0, ip_1.ip2int)(ip, DEFAULT_INT)).toBe(int);
            }
            if (int !== DEFAULT_INT) {
                expect((0, ip_1.int2ip)(int, DEFAULT_IP)).toBe(ip);
            }
        });
    });
});
//# sourceMappingURL=ip.spec.js.map