/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-01-17 14:07:02
 */
import { __read } from "tslib";
import { UINT32_MAX } from './consts';
import { int2ip, ip2int } from './ip';
describe('ip', function () {
    var DEFAULT_INT = 0xfabcdef00;
    var DEFAULT_IP = '11.22.33.44';
    var cases = [
        ['0.0.0.0', 0],
        ['255.255.255.255', UINT32_MAX],
        ['127.0.0.1', 2130706433],
        ['0.0.0.1', 1],
        ['::1', DEFAULT_INT],
        [DEFAULT_IP, Math.pow(2, 32)],
    ];
    it('should convert ip', function () {
        cases.forEach(function (_a) {
            var _b = __read(_a, 2), ip = _b[0], int = _b[1];
            if (ip !== DEFAULT_IP) {
                expect(ip2int(ip, DEFAULT_INT)).toBe(int);
            }
            if (int !== DEFAULT_INT) {
                expect(int2ip(int, DEFAULT_IP)).toBe(ip);
            }
        });
    });
});
//# sourceMappingURL=ip.spec.js.map