"use strict";
/*!
 * Copyright 2018 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2018-07-30 19:05:19
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.isBodyInit = exports.isReadableStream = exports.isURLSearchParams = exports.isFormData = exports.isArrayBufferView = exports.isBufferSource = exports.isFile = exports.isBlob = exports.isMap = exports.isError = exports.isDate = exports.isArray = exports.isObject = void 0;
const falsy = (value) => false;
const isObject = (value) => typeof value === 'object' && value !== null;
exports.isObject = isObject;
const isArray = (value) => value instanceof Array;
exports.isArray = isArray;
const isDate = (value) => value instanceof Date;
exports.isDate = isDate;
const isError = (value) => value instanceof Error ||
    ((0, exports.isObject)(value) && 'name' in value && 'message' in value);
exports.isError = isError;
exports.isMap = typeof Map === 'function'
    ? (value) => value instanceof Map
    : falsy;
exports.isBlob = typeof Blob === 'function'
    ? (input) => input instanceof Blob
    : (input) => false;
exports.isFile = typeof File === 'function'
    ? (input) => input instanceof File
    : (input) => false;
exports.isBufferSource = typeof ArrayBuffer === 'function'
    ? (input) => input instanceof ArrayBuffer || ArrayBuffer.isView(input)
    : (input) => false;
exports.isArrayBufferView = typeof ArrayBuffer === 'function'
    ? ArrayBuffer.isView
    : (input) => false;
exports.isFormData = typeof FormData === 'function'
    ? (input) => input instanceof FormData
    : (input) => false;
exports.isURLSearchParams = typeof URLSearchParams === 'function'
    ? (input) => input instanceof URLSearchParams
    : (input) => false;
exports.isReadableStream = typeof ReadableStream === 'function'
    ? (input) => input instanceof ReadableStream
    : (input) => false;
const isBodyInit = (input) => typeof input === 'string' ||
    (0, exports.isBlob)(input) ||
    (0, exports.isBufferSource)(input) ||
    (0, exports.isFormData)(input) ||
    (0, exports.isURLSearchParams)(input) ||
    (0, exports.isReadableStream)(input);
exports.isBodyInit = isBodyInit;
//# sourceMappingURL=is.js.map