"use strict";
/*!
 *
 * Copyright 2017 - acrazing
 *
 * @author acrazing joking.young@gmail.com
 * @since 2017-12-15 12:29:38
 * @version 1.0.0
 * @desc map.ts
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.values = exports.createMap = void 0;
const tslib_1 = require("tslib");
const consts_1 = require("./consts");
/**
 * create a hashed table, optimized for v8 hidden class
 * @param initial
 */
function createMap(initial) {
    const root = {};
    root['__'] = consts_1.ANY;
    delete root['__'];
    (0, tslib_1.__assign)(root, initial);
    return root;
}
exports.createMap = createMap;
/**
 * get typed values of object
 * @param host
 * @param owned
 */
function values(host, owned = true) {
    if (owned) {
        return Object.keys(host).map((k) => host[k]);
    }
    else {
        const values = [];
        for (const key in host) {
            values.push(host[key]);
        }
        return values;
    }
}
exports.values = values;
//# sourceMappingURL=map.js.map