"use strict";
/*_
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-03-29 14:26:44
 */
Object.defineProperty(exports, "__esModule", { value: true });
const numberFormat_1 = require("./numberFormat");
describe('number format', () => {
    it('should format correctly', () => {
        expect((0, numberFormat_1.itos)(0, 2)).toBe('0');
        expect((0, numberFormat_1.itos)(100, 10)).toBe('100');
        expect((0, numberFormat_1.itos)(0xff, 16)).toBe('FF');
        expect((0, numberFormat_1.itos)(0xfffffffffffff, 2)).toBe('1111111111111111111111111111111111111111111111111111');
        expect((0, numberFormat_1.itos)(0xfffffffffffff, 4)).toBe('33333333333333333333333333');
        expect((0, numberFormat_1.itos)(0xfffffffffffff, 8)).toBe('177777777777777777');
        expect((0, numberFormat_1.itos)(0xfffffffffffff, 10)).toBe('4503599627370495');
        expect((0, numberFormat_1.itos)(0xfffffffffffff, 16)).toBe('FFFFFFFFFFFFF');
        expect((0, numberFormat_1.itos)(0xfffffffffffff, 32)).toBe('3VVVVVVVVVV');
        expect((0, numberFormat_1.itos)(0xfffffffffffff, 64)).toBe('F________');
        expect((0, numberFormat_1.itos)(Number.MAX_SAFE_INTEGER, 64)).toBe('V________');
        expect((0, numberFormat_1.stoi)('V________', 64)).toBe(Number.MAX_SAFE_INTEGER);
        expect((0, numberFormat_1.stoi)('F________', 64)).toBe(0xfffffffffffff);
        expect((0, numberFormat_1.stoi)('3VVVVVVVVVV', 32)).toBe(0xfffffffffffff);
        expect((0, numberFormat_1.stoi)('FFFFFFFFFFFFF', 16)).toBe(0xfffffffffffff);
        expect((0, numberFormat_1.stoi)('4503599627370495', 10)).toBe(0xfffffffffffff);
        expect((0, numberFormat_1.stoi)('177777777777777777', 8)).toBe(0xfffffffffffff);
        expect((0, numberFormat_1.stoi)('33333333333333333333333333', 4)).toBe(0xfffffffffffff);
        expect((0, numberFormat_1.stoi)('1111111111111111111111111111111111111111111111111111', 2)).toBe(0xfffffffffffff);
        expect((0, numberFormat_1.stoi)('?')).toBeNaN();
        const d = Date.now() * 102;
        console.log(d, (0, numberFormat_1.itos)(d));
    });
});
//# sourceMappingURL=numberFormat.spec.js.map