"use strict";
/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-02-18 12:04:55
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.displayType = exports.jsonReplacer = exports.property = void 0;
/**
 * create a property descriptor
 * @param configurable
 * @param enumerable
 * @param writable
 * @param value
 * @param get
 * @param set
 */
function property(configurable, enumerable, writable, value, get, set) {
    return get || set
        ? { configurable, enumerable, get, set }
        : { configurable, enumerable, writable, value };
}
exports.property = property;
/**
 * display Map, Set for JSON.stringify
 * @param key
 * @param value
 */
function jsonReplacer(key, value) {
    if (value instanceof Map) {
        return Array.from(value).reduce((data, [key, value]) => {
            data[key] = value;
            return data;
        }, {});
    }
    if (value instanceof Set) {
        return Array.from(value);
    }
    return value;
}
exports.jsonReplacer = jsonReplacer;
function displayType(value) {
    let type = Object.prototype.toString.call(value);
    if (type === '[object Object]' && value) {
        try {
            type = `[object ${value.constructor.name}]`;
        }
        catch (_a) { }
    }
    return type;
}
exports.displayType = displayType;
//# sourceMappingURL=object.js.map