/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-02-18 12:04:55
 */
import { __read } from "tslib";
/**
 * create a property descriptor
 * @param configurable
 * @param enumerable
 * @param writable
 * @param value
 * @param get
 * @param set
 */
export function property(configurable, enumerable, writable, value, get, set) {
    return get || set
        ? { configurable: configurable, enumerable: enumerable, get: get, set: set }
        : { configurable: configurable, enumerable: enumerable, writable: writable, value: value };
}
/**
 * display Map, Set for JSON.stringify
 * @param key
 * @param value
 */
export function jsonReplacer(key, value) {
    if (value instanceof Map) {
        return Array.from(value).reduce(function (data, _a) {
            var _b = __read(_a, 2), key = _b[0], value = _b[1];
            data[key] = value;
            return data;
        }, {});
    }
    if (value instanceof Set) {
        return Array.from(value);
    }
    return value;
}
export function displayType(value) {
    var type = Object.prototype.toString.call(value);
    if (type === '[object Object]' && value) {
        try {
            type = "[object ".concat(value.constructor.name, "]");
        }
        catch (_a) { }
    }
    return type;
}
//# sourceMappingURL=object.js.map