"use strict";
/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-12-10 15:34:19
 */
Object.defineProperty(exports, "__esModule", { value: true });
const query_string_1 = require("./query-string");
describe('query-string', () => {
    it('should decode/encode as expected', () => {
        expect((0, query_string_1.stringify)({ foo: { bar: 'hello' } })).toBe(`${encodeURIComponent('foo[bar]')}=hello`);
        expect((0, query_string_1.stringify)({ foo: { bar: (() => () => 1)() } })).toBe(`${encodeURIComponent('foo[bar]')}=${encodeURIComponent('[Function (anonymous)]')}`);
        expect((0, query_string_1.stringify)({ foo: { bar: () => 1 } })).toBe(`${encodeURIComponent('foo[bar]')}=${encodeURIComponent('[Function bar]')}`);
        expect((0, query_string_1.stringify)({
            foo: {
                bar: function baz() { },
            },
        })).toBe(`${encodeURIComponent('foo[bar]')}=${encodeURIComponent('[Function baz]')}`);
        expect((0, query_string_1.parse)('foo[bar]=hello')).toEqual({ foo: { bar: 'hello' } });
        expect((0, query_string_1.parse)(`${encodeURIComponent('foo[bar]')}=hello`)).toEqual({
            foo: { bar: 'hello' },
        });
        expect((0, query_string_1.parse)('foo=bar=&baz=pat')).toEqual({ foo: 'bar=', baz: 'pat' });
    });
});
//# sourceMappingURL=query-string.spec.js.map