/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-12-10 15:34:19
 */
import { parse, stringify } from './query-string';
describe('query-string', function () {
    it('should decode/encode as expected', function () {
        expect(stringify({ foo: { bar: 'hello' } })).toBe("".concat(encodeURIComponent('foo[bar]'), "=hello"));
        expect(stringify({ foo: { bar: (function () { return function () { return 1; }; })() } })).toBe("".concat(encodeURIComponent('foo[bar]'), "=").concat(encodeURIComponent('[Function (anonymous)]')));
        expect(stringify({ foo: { bar: function () { return 1; } } })).toBe("".concat(encodeURIComponent('foo[bar]'), "=").concat(encodeURIComponent('[Function bar]')));
        expect(stringify({
            foo: {
                bar: function baz() { },
            },
        })).toBe("".concat(encodeURIComponent('foo[bar]'), "=").concat(encodeURIComponent('[Function baz]')));
        expect(parse('foo[bar]=hello')).toEqual({ foo: { bar: 'hello' } });
        expect(parse("".concat(encodeURIComponent('foo[bar]'), "=hello"))).toEqual({
            foo: { bar: 'hello' },
        });
        expect(parse('foo=bar=&baz=pat')).toEqual({ foo: 'bar=', baz: 'pat' });
    });
});
//# sourceMappingURL=query-string.spec.js.map