"use strict";
/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-01-17 12:14:56
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.requestGuid = void 0;
const request_guid_1 = require("./request-guid");
function requestGuid(options) {
    const { secret, header = 'x-request-id', name, trustHeader = true } = options;
    const encoder = (0, request_guid_1.createEncoder)(secret);
    return (req, res, next) => {
        if (trustHeader) {
            const input = req.headers[header];
            const upstream = input
                ? Array.isArray(input)
                    ? input[0]
                    : input
                : void 0;
            if (upstream && (0, request_guid_1.isGuid)(upstream)) {
                req[name] = upstream;
                res.setHeader(header, upstream);
                next();
                return;
            }
        }
        const id = (req[name] = encoder(req.connection.localAddress, req.ip));
        res.setHeader(header, id);
        next();
    };
}
exports.requestGuid = requestGuid;
//# sourceMappingURL=request-guid.express.js.map