/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-01-17 12:14:56
 */
import { createEncoder, isGuid } from './request-guid';
export function requestGuid(options) {
    var secret = options.secret, _a = options.header, header = _a === void 0 ? 'x-request-id' : _a, name = options.name, _b = options.trustHeader, trustHeader = _b === void 0 ? true : _b;
    var encoder = createEncoder(secret);
    return function (req, res, next) {
        if (trustHeader) {
            var input = req.headers[header];
            var upstream = input
                ? Array.isArray(input)
                    ? input[0]
                    : input
                : void 0;
            if (upstream && isGuid(upstream)) {
                req[name] = upstream;
                res.setHeader(header, upstream);
                next();
                return;
            }
        }
        var id = (req[name] = encoder(req.connection.localAddress, req.ip));
        res.setHeader(header, id);
        next();
    };
}
//# sourceMappingURL=request-guid.express.js.map