"use strict";
/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-02-16 11:06:04
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTypeTree = void 0;
function createTypeTree(prefix, tree) {
    if (prefix.charAt(prefix.length - 1) !== '.') {
        prefix += '.';
    }
    for (const key in tree) {
        if (tree.hasOwnProperty(key)) {
            const value = tree[key];
            if (typeof value === 'string') {
                tree[key] = prefix + (value || key);
            }
            else {
                createTypeTree(prefix + key + '.', value);
            }
        }
    }
    return tree;
}
exports.createTypeTree = createTypeTree;
//# sourceMappingURL=type-tree.js.map